////////////////////////////////////////////////////////////////////////
// PongC02.c
// Mochilote - www.cpcmania.com
////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


////////////////////////////////////////////////////////////////////////
//------------------------ Generic functions -------------------------//
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//GetTime()
////////////////////////////////////////////////////////////////////////
unsigned char char3,char4;

unsigned int GetTime()
{
	unsigned int nTime = 0;

	__asm
		CALL #0xBD0D ;KL TIME PLEASE
		PUSH HL
		POP DE
		LD HL, #_char3
		LD (HL), D
		LD HL, #_char4
		LD (HL), E
	__endasm;

	nTime = (char3 << 8) + char4;

	return nTime;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//SetColor
////////////////////////////////////////////////////////////////////////
void SetColor(unsigned char nColorIndex, unsigned char nPaletteIndex)
{
	__asm
		ld a, 4 (ix)
		ld b, 5 (ix)
		ld c, b
		call #0xBC32 ;SCR SET INK
	__endasm;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//SetMode
////////////////////////////////////////////////////////////////////////
void SetMode(unsigned char nMode)
{
	__asm
		ld a, 4 (ix)
		call #0xBC0E ;SCR_SET_MODE
	__endasm;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//SetBorder
////////////////////////////////////////////////////////////////////////
void SetBorder(unsigned char nColor)
{
	__asm
		ld b, 4 (ix)
		ld c, b
		call #0xBC38 ;SCR_SET_BORDER
	__endasm;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//SetCursor
////////////////////////////////////////////////////////////////////////
void SetCursor(unsigned char nColum, unsigned char nLine)
{
	__asm
		ld h, 4 (ix)
		ld l, 5 (ix)
		call #0xBB75 ;TXT SET CURSOR
	__endasm;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//LineHMode2
////////////////////////////////////////////////////////////////////////
void LineHMode2(unsigned int nX, unsigned int nY, unsigned char nColor, unsigned int nWidth)
{
	unsigned char *pAddress = (unsigned char *)0xC000 + ((nY / 8) * 80) + ((nY % 8) * 2048) + (nX / 8);
	
	if(nX % 8 == 0 && nWidth % 8 == 0)
	{
		memset(pAddress, nColor ? 0xFF : 0x00, nWidth / 8);
	}
	else
	{
		unsigned int nPixels = 0;
		unsigned int nX2 = 0;
		
		//first byte
		for(nX2 = nX; (nX2 % 8) && (nX2 < nX + nWidth); nX2++)
		{
			unsigned char nBit = 7 - nX2 % 8;
			unsigned char nAux = 0;
			
			if(nColor == 0)
			{
				nAux = ~(1 << nBit);
				*pAddress = *pAddress & nAux;
			}
			else
			{
				nAux = (1 << nBit);
				*pAddress = *pAddress | nAux;
			}
			
			nPixels++;
		}
		
		if(nPixels > 0)
			pAddress++;
		
		//intermediate bytes
		nX2 = (nWidth - nPixels) / 8;
		memset(pAddress, nColor ? 0xFF : 0x00, nX2);
		nPixels += nX2 * 8;
		pAddress += nX2;
		
		//last byte
		for(nX2 = nX + nPixels; (nX2 < nX + nWidth); nX2++)
		{
			unsigned char nBit = 7 - nX2 % 8;
			unsigned char nAux = 0;
			
			if(nColor == 0)
			{
				nAux = ~(1 << nBit);
				*pAddress = *pAddress & nAux;
			}
			else
			{
				nAux = (1 << nBit);
				*pAddress = *pAddress | nAux;
			}
			
			nPixels++;
		}		
	}
}
////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////
//---------------- Specific variables and functions-------------------//
////////////////////////////////////////////////////////////////////////

#define BALL_WIDTH 20
#define BALL_HEIGHT 10

////////////////////////////////////////////////////////////////////////
//DrawBall
////////////////////////////////////////////////////////////////////////
void DrawBall(unsigned int nX, unsigned int nY)
{
	unsigned int nAux = 0;
	
	for(nAux = 0; nAux < BALL_HEIGHT; nAux++)
		LineHMode2(nX, nY + nAux, 1, BALL_WIDTH);	
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//main
////////////////////////////////////////////////////////////////////////
void main()
{
	unsigned int nFPS = 0;
	unsigned int nTimeLast = 0;
	unsigned int nX = 0;
	unsigned int nY = 0;
	
	SetMode(2);
	SetBorder(0);
	SetColor(0, 0);
	SetColor(1, 26);
  
	nTimeLast = GetTime();

	while(1)
	{
		nFPS++;

		if(GetTime() - nTimeLast >= 300)
		{
			SetCursor(1, 1);
			printf("%u  ", nFPS);

			nTimeLast = GetTime();
			nFPS = 0;
		}

		nX = (nX + 1) % (640 - BALL_WIDTH);
		nY = (nY + 1) % (200 - BALL_HEIGHT);
		DrawBall(nX, nY);
	}
}
////////////////////////////////////////////////////////////////////////