////////////////////////////////////////////////////////////////////////
// PongC03.c
// Mochilote - www.cpcmania.com
////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


////////////////////////////////////////////////////////////////////////
//------------------------ Generic functions -------------------------//
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//GetTime()
////////////////////////////////////////////////////////////////////////
unsigned char char3,char4;

unsigned int GetTime()
{
	unsigned int nTime = 0;

	__asm
		CALL #0xBD0D ;KL TIME PLEASE
		PUSH HL
		POP DE
		LD HL, #_char3
		LD (HL), D
		LD HL, #_char4
		LD (HL), E
	__endasm;

	nTime = (char3 << 8) + char4;

	return nTime;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//SetColor
////////////////////////////////////////////////////////////////////////
void SetColor(unsigned char nColorIndex, unsigned char nPaletteIndex)
{
	__asm
		ld a, 4 (ix)
		ld b, 5 (ix)
		ld c, b
		call #0xBC32 ;SCR SET INK
	__endasm;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//SetMode
////////////////////////////////////////////////////////////////////////
void SetMode(unsigned char nMode)
{
	__asm
		ld a, 4 (ix)
		call #0xBC0E ;SCR_SET_MODE
	__endasm;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//SetBorder
////////////////////////////////////////////////////////////////////////
void SetBorder(unsigned char nColor)
{
	__asm
		ld b, 4 (ix)
		ld c, b
		call #0xBC38 ;SCR_SET_BORDER
	__endasm;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//SetCursor
////////////////////////////////////////////////////////////////////////
void SetCursor(unsigned char nColum, unsigned char nLine)
{
	__asm
		ld h, 4 (ix)
		ld l, 5 (ix)
		call #0xBB75 ;TXT SET CURSOR
	__endasm;
}
////////////////////////////////////////////////////////////////////////


const unsigned char aMode2Left[8] = { 0xFF, 0x7F, 0x3F, 0x1F, 0x0F, 0x07, 0x03, 0x01};
const unsigned char aMode2Right[8] = { 0xFF, 0x80, 0xC0, 0xE0, 0xF0, 0xF8, 0xFC, 0xFE};

////////////////////////////////////////////////////////////////////////
//LineHMode2
////////////////////////////////////////////////////////////////////////
void LineHMode2(unsigned int nX, unsigned int nY, unsigned char nColor, unsigned int nWidth)
{
	unsigned char *pAddress = (unsigned char *)0xC000 + ((nY / 8) * 80) + ((nY % 8) * 2048) + (nX / 8);
	
	if(nColor == 0 || (nX % 8 == 0 && nWidth % 8 == 0))
	{
		memset(pAddress, nColor ? 0xFF : 0x00, nWidth / 8 + (nWidth % 8 ? 1 : 0));
	}
	else
	{
		unsigned int nPixels = 0;
		unsigned int nAux = 0;
		
		//first byte
		nAux = nX % 8;
		
		if(nAux)
		{
			*pAddress++ = *(aMode2Left + nAux);
			nPixels += 8 - nAux;
		}
		
		//intermediate bytes
		nAux = (nWidth - nPixels) / 8;
		memset(pAddress, 0xFF, nAux);
		nPixels += nAux * 8;
		pAddress += nAux;
		
		//last byte
		nAux = nWidth - nPixels;

		if(nAux)
			*pAddress++ = *(aMode2Right + nAux);
	}
}
////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////
//---------------- Specific variables and functions-------------------//
////////////////////////////////////////////////////////////////////////

#define BALL_WIDTH 20
#define BALL_HEIGHT 10

////////////////////////////////////////////////////////////////////////
//DrawBall
////////////////////////////////////////////////////////////////////////
void DrawBall(unsigned int nX, unsigned int nY)
{
	unsigned int nAux = 0;
	
	for(nAux = 0; nAux < BALL_HEIGHT; nAux++)
		LineHMode2(nX, nY + nAux, 1, BALL_WIDTH);	
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//main
////////////////////////////////////////////////////////////////////////
void main()
{
	unsigned int nFPS = 0;
	unsigned int nTimeLast = 0;
	unsigned int nX = 0;
	unsigned int nY = 0;
	
	SetMode(2);
	SetBorder(0);
	SetColor(0, 0);
	SetColor(1, 26);
  
	nTimeLast = GetTime();

	while(1)
	{
		nFPS++;

		if(GetTime() - nTimeLast >= 300)
		{
			SetCursor(1, 1);
			printf("%u  ", nFPS);

			nTimeLast = GetTime();
			nFPS = 0;
		}

		nX = (nX + 1) % (640 - BALL_WIDTH);
		nY = (nY + 1) % (200 - BALL_HEIGHT);
		DrawBall(nX, nY);
	}
}
////////////////////////////////////////////////////////////////////////