////////////////////////////////////////////////////////////////////////
// PongC05.c
// Mochilote - www.cpcmania.com
////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


////////////////////////////////////////////////////////////////////////
//------------------------ Generic functions -------------------------//
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//GetTime()
////////////////////////////////////////////////////////////////////////
unsigned char char3,char4;

unsigned int GetTime()
{
	unsigned int nTime = 0;

	__asm
		CALL #0xBD0D ;KL TIME PLEASE
		PUSH HL
		POP DE
		LD HL, #_char3
		LD (HL), D
		LD HL, #_char4
		LD (HL), E
	__endasm;

	nTime = (char3 << 8) + char4;

	return nTime;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//SetColor
////////////////////////////////////////////////////////////////////////
void SetColor(unsigned char nColorIndex, unsigned char nPaletteIndex)
{
	__asm
		ld a, 4 (ix)
		ld b, 5 (ix)
		ld c, b
		call #0xBC32 ;SCR SET INK
	__endasm;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//SetMode
////////////////////////////////////////////////////////////////////////
void SetMode(unsigned char nMode)
{
	__asm
		ld a, 4 (ix)
		call #0xBC0E ;SCR_SET_MODE
	__endasm;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//SetBorder
////////////////////////////////////////////////////////////////////////
void SetBorder(unsigned char nColor)
{
	__asm
		ld b, 4 (ix)
		ld c, b
		call #0xBC38 ;SCR_SET_BORDER
	__endasm;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//SetCursor
////////////////////////////////////////////////////////////////////////
void SetCursor(unsigned char nColum, unsigned char nLine)
{
	__asm
		ld h, 4 (ix)
		ld l, 5 (ix)
		call #0xBB75 ;TXT SET CURSOR
	__endasm;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//PutSprite()
////////////////////////////////////////////////////////////////////////
void PutSprite(unsigned char *pAddress, unsigned char nWidth, unsigned char nHeight, unsigned char *pSprite)
{
	__asm
		LD L, 4(IX) 
		LD H, 5(IX) 
		LD C, 6(IX) 
		LD B, 7(IX)            
		LD E, 8(IX) 
		LD D, 9(IX) 

		_loop_alto:
			PUSH BC
			LD B,C
			PUSH HL
		_loop_ancho:
			LD A,(DE)
			LD (HL),A
			INC DE
			INC HL
			DJNZ _loop_ancho
			POP HL
			LD A,H
			ADD #0x08
			LD H,A
			SUB #0xC0
			JP NC, _sig_linea
			LD BC, #0xC050
			ADD HL,BC
		_sig_linea:
			POP BC
			DJNZ _loop_alto
	__endasm;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//WaitVsync
////////////////////////////////////////////////////////////////////////
void WaitVsync()
{
	__asm
		ld b,#0xf5          ;; PPI port B input
		_wait_vsync:
		in a,(c)            ;; [4] read PPI port B input
    		                ;; (bit 0 = "1" if vsync is active,
    		                ;;  or bit 0 = "0" if vsync is in-active)
		rra                 ;; [1] put bit 0 into carry flag
		jp nc,_wait_vsync   ;; [3] if carry not set, loop, otherwise continue
	__endasm;
}
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//---------------- Specific variables and functions-------------------//
////////////////////////////////////////////////////////////////////////

#define BALL_WIDTH 20
#define BALL_HEIGHT 10

#define BALL_WIDTH_BYTES 4
const unsigned char aBallSprite[9][BALL_WIDTH_BYTES * BALL_HEIGHT] = 
{
												{	0xFF,	0xFF,	0xF0,	0x00,
													0xFF,	0xFF,	0xF0,	0x00,
													0xFF,	0xFF,	0xF0,	0x00,
													0xFF,	0xFF,	0xF0,	0x00,
													0xFF,	0xFF,	0xF0,	0x00,
													0xFF,	0xFF,	0xF0,	0x00,
													0xFF,	0xFF,	0xF0,	0x00,
													0xFF,	0xFF,	0xF0,	0x00,
													0xFF,	0xFF,	0xF0,	0x00,
													0xFF,	0xFF,	0xF0,	0x00 },
													
												{	0x7F,	0xFF,	0xF8,	0x00,
													0x7F,	0xFF,	0xF8,	0x00,
													0x7F,	0xFF,	0xF8,	0x00,
													0x7F,	0xFF,	0xF8,	0x00,
													0x7F,	0xFF,	0xF8,	0x00,
													0x7F,	0xFF,	0xF8,	0x00,
													0x7F,	0xFF,	0xF8,	0x00,
													0x7F,	0xFF,	0xF8,	0x00,
													0x7F,	0xFF,	0xF8,	0x00,
													0x7F,	0xFF,	0xF8,	0x00 },
													
												{	0x3F,	0xFF,	0xFC,	0x00,
													0x3F,	0xFF,	0xFC,	0x00,
													0x3F,	0xFF,	0xFC,	0x00,
													0x3F,	0xFF,	0xFC,	0x00,
													0x3F,	0xFF,	0xFC,	0x00,
													0x3F,	0xFF,	0xFC,	0x00,
													0x3F,	0xFF,	0xFC,	0x00,
													0x3F,	0xFF,	0xFC,	0x00,
													0x3F,	0xFF,	0xFC,	0x00,
													0x3F,	0xFF,	0xFC,	0x00 },
													
												{	0x1F,	0xFF,	0xFE,	0x00,
													0x1F,	0xFF,	0xFE,	0x00,
													0x1F,	0xFF,	0xFE,	0x00,
													0x1F,	0xFF,	0xFE,	0x00,
													0x1F,	0xFF,	0xFE,	0x00,
													0x1F,	0xFF,	0xFE,	0x00,
													0x1F,	0xFF,	0xFE,	0x00,
													0x1F,	0xFF,	0xFE,	0x00,
													0x1F,	0xFF,	0xFE,	0x00,
													0x1F,	0xFF,	0xFE,	0x00 },
													
												{	0x0F,	0xFF,	0xFF,	0x00,
													0x0F,	0xFF,	0xFF,	0x00,
													0x0F,	0xFF,	0xFF,	0x00,
													0x0F,	0xFF,	0xFF,	0x00,
													0x0F,	0xFF,	0xFF,	0x00,
													0x0F,	0xFF,	0xFF,	0x00,
													0x0F,	0xFF,	0xFF,	0x00,
													0x0F,	0xFF,	0xFF,	0x00,
													0x0F,	0xFF,	0xFF,	0x00,
													0x0F,	0xFF,	0xFF,	0x00 },
													
												{	0x07,	0xFF,	0xFF,	0x80,
													0x07,	0xFF,	0xFF,	0x80,
													0x07,	0xFF,	0xFF,	0x80,
													0x07,	0xFF,	0xFF,	0x80,
													0x07,	0xFF,	0xFF,	0x80,
													0x07,	0xFF,	0xFF,	0x80,
													0x07,	0xFF,	0xFF,	0x80,
													0x07,	0xFF,	0xFF,	0x80,
													0x07,	0xFF,	0xFF,	0x80,
													0x07,	0xFF,	0xFF,	0x80 },
													
												{	0x03,	0xFF,	0xFF,	0xC0,
													0x03,	0xFF,	0xFF,	0xC0,
													0x03,	0xFF,	0xFF,	0xC0,
													0x03,	0xFF,	0xFF,	0xC0,
													0x03,	0xFF,	0xFF,	0xC0,
													0x03,	0xFF,	0xFF,	0xC0,
													0x03,	0xFF,	0xFF,	0xC0,
													0x03,	0xFF,	0xFF,	0xC0,
													0x03,	0xFF,	0xFF,	0xC0,
													0x03,	0xFF,	0xFF,	0xC0 },
													
												{	0x01,	0xFF,	0xFF,	0xE0,
													0x01,	0xFF,	0xFF,	0xE0,
													0x01,	0xFF,	0xFF,	0xE0,
													0x01,	0xFF,	0xFF,	0xE0,
													0x01,	0xFF,	0xFF,	0xE0,
													0x01,	0xFF,	0xFF,	0xE0,
													0x01,	0xFF,	0xFF,	0xE0,
													0x01,	0xFF,	0xFF,	0xE0,
													0x01,	0xFF,	0xFF,	0xE0,
													0x01,	0xFF,	0xFF,	0xE0 },
													
												{	0x00,	0x00,	0x00,	0x00,
													0x00,	0x00,	0x00,	0x00,
													0x00,	0x00,	0x00,	0x00,
													0x00,	0x00,	0x00,	0x00,
													0x00,	0x00,	0x00,	0x00,
													0x00,	0x00,	0x00,	0x00,
													0x00,	0x00,	0x00,	0x00,
													0x00,	0x00,	0x00,	0x00,
													0x00,	0x00,	0x00,	0x00,
													0x00,	0x00,	0x00,	0x00 },
};


////////////////////////////////////////////////////////////////////////
//main
////////////////////////////////////////////////////////////////////////
void main()
{
	unsigned int nFPS = 0;
	unsigned int nTimeLast = 0;
	unsigned int nX = 0;
	unsigned int nY = 0;
	
	SetMode(2);
	SetBorder(0);
	SetColor(0, 0);
	SetColor(1, 26);
  
	nTimeLast = GetTime();

	while(1)
	{
		if(GetTime() - nTimeLast >= 300)
		{
			SetCursor(1, 1);
			printf("%u  ", nFPS);

			nTimeLast += 300;
			nFPS = 0;
		}

		WaitVsync();
		PutSprite((unsigned char *)0xC000 + ((nY / 8) * 80) + ((nY % 8) * 2048) + (nX / 8), BALL_WIDTH_BYTES, BALL_HEIGHT, aBallSprite[8]);
		nX = (nX + 1) % (640 - BALL_WIDTH);
		nY = (nY + 1) % (200 - BALL_HEIGHT);
		PutSprite((unsigned char *)0xC000 + ((nY / 8) * 80) + ((nY % 8) * 2048) + (nX / 8), BALL_WIDTH_BYTES, BALL_HEIGHT, aBallSprite[nX % 8]);

		nFPS++;
	}
}
////////////////////////////////////////////////////////////////////////